Improve packer-validate debugging output
[releng/global-jjb.git] / .jjb-test / expected-xml / github-ciman-packer-verify
1 <?xml version="1.0" encoding="utf-8"?>
2 <project>
3   <actions/>
4   <description>&lt;!-- Managed by Jenkins Job Builder --&gt;</description>
5   <keepDependencies>false</keepDependencies>
6   <blockBuildWhenDownstreamBuilding>false</blockBuildWhenDownstreamBuilding>
7   <blockBuildWhenUpstreamBuilding>false</blockBuildWhenUpstreamBuilding>
8   <concurrentBuild>true</concurrentBuild>
9   <assignedNode>build-vm</assignedNode>
10   <canRoam>false</canRoam>
11   <properties>
12     <com.coravy.hudson.plugins.github.GithubProjectProperty>
13       <projectUrl>https://github.com/example-org/releng/ciman</projectUrl>
14     </com.coravy.hudson.plugins.github.GithubProjectProperty>
15     <hudson.model.ParametersDefinitionProperty>
16       <parameterDefinitions>
17         <hudson.model.StringParameterDefinition>
18           <name>PROJECT</name>
19           <description>Parameter to identify a Gerrit project. This is typically the
20 project repo path as exists in Gerrit.
21 For example: ofextensions/circuitsw
22 </description>
23           <defaultValue>releng/ciman</defaultValue>
24         </hudson.model.StringParameterDefinition>
25         <hudson.model.StringParameterDefinition>
26           <name>STREAM</name>
27           <description>Stream is often set to the same name as 'branch' but can
28 sometimes be used as a name representing a project's release code
29 name.
30 </description>
31           <defaultValue>master</defaultValue>
32         </hudson.model.StringParameterDefinition>
33         <hudson.model.StringParameterDefinition>
34           <name>GERRIT_PROJECT</name>
35           <description>Parameter to identify Gerrit project. This is typically the
36 project repo path as exists in Gerrit.
37 For example: ofextensions/circuitsw
38
39 Note that Gerrit will override this parameter automatically if a
40 job is triggered by Gerrit.
41 </description>
42           <defaultValue>releng/ciman</defaultValue>
43         </hudson.model.StringParameterDefinition>
44         <hudson.model.StringParameterDefinition>
45           <name>GERRIT_BRANCH</name>
46           <description>Parameter to identify a Gerrit branch.
47
48 Note that Gerrit will override this parameter automatically if a
49 job is triggered by Gerrit.
50 </description>
51           <defaultValue>master</defaultValue>
52         </hudson.model.StringParameterDefinition>
53         <hudson.model.StringParameterDefinition>
54           <name>GERRIT_REFSPEC</name>
55           <description>Parameter to identify a refspec when pulling from Gerrit.
56
57 Note that Gerrit will override this parameter automatically if a
58 job is triggered by Gerrit.
59 </description>
60           <defaultValue>refs/heads/master</defaultValue>
61         </hudson.model.StringParameterDefinition>
62         <hudson.model.StringParameterDefinition>
63           <name>LFTOOLS_VERSION</name>
64           <description>Version of lftools to install. Can be a specific version like
65 '0.6.0' or a PEP-440 definition.
66 https://www.python.org/dev/peps/pep-0440/
67 For example '&lt;1.0.0' or '&gt;=1.0.0,&lt;2.0.0'.
68 </description>
69           <defaultValue>&lt;1.0.0</defaultValue>
70         </hudson.model.StringParameterDefinition>
71         <hudson.model.StringParameterDefinition>
72           <name>PACKER_VERSION</name>
73           <description>Packer version to download and install.</description>
74           <defaultValue>1.1.3</defaultValue>
75         </hudson.model.StringParameterDefinition>
76       </parameterDefinitions>
77     </hudson.model.ParametersDefinitionProperty>
78   </properties>
79   <scm class="hudson.plugins.git.GitSCM">
80     <configVersion>2</configVersion>
81     <userRemoteConfigs>
82       <hudson.plugins.git.UserRemoteConfig>
83         <name>origin</name>
84         <refspec>+refs/pull/*:refs/remotes/origin/pr/*</refspec>
85         <url>git@github.com:example-org/releng/ciman</url>
86         <credentialsId>test-credential</credentialsId>
87       </hudson.plugins.git.UserRemoteConfig>
88     </userRemoteConfigs>
89     <branches>
90       <hudson.plugins.git.BranchSpec>
91         <name>$sha1</name>
92       </hudson.plugins.git.BranchSpec>
93     </branches>
94     <excludedUsers/>
95     <buildChooser class="hudson.plugins.git.util.DefaultBuildChooser"/>
96     <doGenerateSubmoduleConfigurations>false</doGenerateSubmoduleConfigurations>
97     <authorOrCommitter>false</authorOrCommitter>
98     <wipeOutWorkspace>true</wipeOutWorkspace>
99     <pruneBranches>false</pruneBranches>
100     <remotePoll>false</remotePoll>
101     <gitTool>Default</gitTool>
102     <submoduleCfg class="list"/>
103     <relativeTargetDir/>
104     <reference/>
105     <gitConfigName/>
106     <gitConfigEmail/>
107     <skipTag>true</skipTag>
108     <scmName/>
109     <useShallowClone>false</useShallowClone>
110     <ignoreNotifyCommit>false</ignoreNotifyCommit>
111     <extensions>
112       <hudson.plugins.git.extensions.impl.SubmoduleOption>
113         <disableSubmodules>false</disableSubmodules>
114         <recursiveSubmodules>true</recursiveSubmodules>
115         <trackingSubmodules>false</trackingSubmodules>
116         <reference/>
117         <timeout>10</timeout>
118       </hudson.plugins.git.extensions.impl.SubmoduleOption>
119       <hudson.plugins.git.extensions.impl.WipeWorkspace/>
120     </extensions>
121   </scm>
122   <triggers class="vector">
123     <org.jenkinsci.plugins.ghprb.GhprbTrigger>
124       <spec/>
125       <adminlist/>
126       <allowMembersOfWhitelistedOrgsAsAdmin>false</allowMembersOfWhitelistedOrgsAsAdmin>
127       <whitelist/>
128       <orgslist/>
129       <cron/>
130       <triggerPhrase>^recheck$</triggerPhrase>
131       <onlyTriggerPhrase>false</onlyTriggerPhrase>
132       <useGitHubHooks>true</useGitHubHooks>
133       <permitAll>true</permitAll>
134       <autoCloseFailedPullRequests>false</autoCloseFailedPullRequests>
135       <extensions>
136         <org.jenkinsci.plugins.ghprb.extensions.status.GhprbSimpleStatus>
137           <commitStatusContext>Packer Verify</commitStatusContext>
138         </org.jenkinsci.plugins.ghprb.extensions.status.GhprbSimpleStatus>
139       </extensions>
140     </org.jenkinsci.plugins.ghprb.GhprbTrigger>
141   </triggers>
142   <builders>
143     <org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep plugin="config-file-provider">
144       <managedFiles>
145         <org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
146           <fileId>ci-packer-cloud-env</fileId>
147           <targetLocation/>
148           <variable>CLOUDENV</variable>
149         </org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
150       </managedFiles>
151     </org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep>
152     <EnvInjectBuilder>
153       <info>
154         <propertiesContent>PACKER_VERSION=1.1.3
155 </propertiesContent>
156       </info>
157     </EnvInjectBuilder>
158     <hudson.tasks.Shell>
159       <command>#!/bin/bash
160 # SPDX-License-Identifier: EPL-1.0
161 ##############################################################################
162 # Copyright (c) 2017 The Linux Foundation and others.
163 #
164 # All rights reserved. This program and the accompanying materials
165 # are made available under the terms of the Eclipse Public License v1.0
166 # which accompanies this distribution, and is available at
167 # http://www.eclipse.org/legal/epl-v10.html
168 ##############################################################################
169 echo &quot;---&gt; packer-install.sh&quot;
170 # The script checks for the packer binaries and installs the binary
171 # if its not available
172
173 # $PACKER_VERSION        : Define a packer version passed as job paramter
174
175 PACKER_VERSION=&quot;${PACKER_VERSION:-1.1.3}&quot;
176
177 # Ensure we fail the job if any steps fail.
178 set -eu -o pipefail
179
180 if hash packer.io 2&gt;/dev/null; then
181     echo &quot;packer.io command is available.&quot;
182 else
183     echo &quot;packer.io command not is available. Installing packer ...&quot;
184     # Installs Hashicorp's Packer binary, required for verify &amp; merge packer jobs
185     pushd packer
186     wget -nv &quot;https://releases.hashicorp.com/packer/${PACKER_VERSION}/packer_${PACKER_VERSION}_linux_amd64.zip&quot;
187     mkdir -p &quot;${WORKSPACE}/bin&quot;
188     unzip &quot;packer_${PACKER_VERSION}_linux_amd64.zip&quot; -d ${WORKSPACE}/bin/
189     # rename packer to avoid conflict with binary in cracklib
190     mv ${WORKSPACE}/bin/packer &quot;${WORKSPACE}/bin/packer.io&quot;
191     popd
192 fi
193
194 #!/bin/bash
195 # SPDX-License-Identifier: EPL-1.0
196 ##############################################################################
197 # Copyright (c) 2017 The Linux Foundation and others.
198 #
199 # All rights reserved. This program and the accompanying materials
200 # are made available under the terms of the Eclipse Public License v1.0
201 # which accompanies this distribution, and is available at
202 # http://www.eclipse.org/legal/epl-v10.html
203 ##############################################################################
204 echo &quot;---&gt; packer-validate.sh&quot;
205 # The script validates an packers files.
206
207 # $CLOUDENV            :  Provides the cloud credential file.
208
209 # Ensure we fail the job if any steps fail.
210 set -eu -o pipefail
211
212 PACKER_LOGS_DIR=&quot;$WORKSPACE/archives/packer&quot;
213 mkdir -p &quot;$PACKER_LOGS_DIR&quot;
214 export PATH=&quot;${WORKSPACE}/bin:$PATH&quot;
215
216 cd packer
217 varfiles=(vars/*.json common-packer/vars/*.json)
218 templates=(templates/*.json)
219
220 for varfile in &quot;${varfiles[@]}&quot;; do
221     # cloud-env.json is a file containing credentials which is pulled in via
222     # CLOUDENV variable so skip it here.
223     if [[ &quot;$varfile&quot; == *&quot;cloud-env.json&quot;* ]]; then
224         continue
225     fi
226
227     echo &quot;-----&gt; Testing varfile: $varfile&quot;
228     for template in &quot;${templates[@]}&quot;; do
229         export PACKER_LOG=&quot;yes&quot;
230         export PACKER_LOG_PATH=&quot;$PACKER_LOGS_DIR/packer-validate-${varfile##*/}-${template##*/}.log&quot;
231         if output=$(packer.io validate -var-file=&quot;$CLOUDENV&quot; -var-file=&quot;$varfile&quot; &quot;$template&quot;); then
232             echo &quot;$template: $output&quot;
233         else
234             echo &quot;$template: $output&quot;
235             exit 1
236         fi
237     done
238 done
239 </command>
240     </hudson.tasks.Shell>
241     <hudson.tasks.Shell>
242       <command>#!/bin/bash
243 # SPDX-License-Identifier: EPL-1.0
244 ##############################################################################
245 # Copyright (c) 2017 The Linux Foundation and others.
246 #
247 # All rights reserved. This program and the accompanying materials
248 # are made available under the terms of the Eclipse Public License v1.0
249 # which accompanies this distribution, and is available at
250 # http://www.eclipse.org/legal/epl-v10.html
251 ##############################################################################
252 echo &quot;---&gt; packer-clear-credentials.sh&quot;
253
254 set +e  # DO NOT cause build failure if any of the rm calls fail.
255 rm &quot;$CLOUDENV&quot;
256 exit 0
257 </command>
258     </hudson.tasks.Shell>
259   </builders>
260   <publishers>
261     <org.jenkinsci.plugins.postbuildscript.PostBuildScript>
262       <buildSteps>
263         <hudson.tasks.Shell>
264           <command>#!/bin/bash
265 # SPDX-License-Identifier: EPL-1.0
266 ##############################################################################
267 # Copyright (c) 2017 The Linux Foundation and others.
268 #
269 # All rights reserved. This program and the accompanying materials
270 # are made available under the terms of the Eclipse Public License v1.0
271 # which accompanies this distribution, and is available at
272 # http://www.eclipse.org/legal/epl-v10.html
273 ##############################################################################
274 echo &quot;---&gt; sysstat.sh&quot;
275 set +e  # DON'T fail build if script fails.
276
277 OS=$(facter operatingsystem)
278 case &quot;$OS&quot; in
279     Ubuntu)
280         SYSSTAT_PATH=&quot;/var/log/sysstat&quot;
281
282         # Dont run the script when systat is not enabled by default
283         if ! grep --quiet 'ENABLED=&quot;true&quot;' &quot;/etc/default/sysstat&quot;; then
284             exit 0
285         fi
286     ;;
287     CentOS|RedHat)
288         SYSSTAT_PATH=&quot;/var/log/sa&quot;
289     ;;
290     *)
291         # nothing to do
292         exit 0
293     ;;
294 esac
295
296 SAR_DIR=&quot;$WORKSPACE/archives/sar-reports&quot;
297 mkdir -p &quot;$SAR_DIR&quot;
298 cp &quot;$SYSSTAT_PATH/&quot;* &quot;$_&quot;
299 # convert sar data to ascii format
300 while IFS=&quot;&quot; read -r sarfilenum
301 do
302     [ -f &quot;$sarfilenum&quot; ] &amp;&amp; LC_TIME=POSIX sar -A -f &quot;$sarfilenum&quot; &gt; &quot;$SAR_DIR/sar${sarfilenum//[!0-9]/}&quot;
303 done &lt; &lt;(find &quot;$SYSSTAT_PATH&quot; -name &quot;sa[0-9]*&quot; || true)
304
305 # DON'T fail build if script fails.
306 exit 0
307 </command>
308         </hudson.tasks.Shell>
309         <org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep plugin="config-file-provider">
310           <managedFiles>
311             <org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
312               <fileId>jenkins-log-archives-settings</fileId>
313               <targetLocation/>
314               <variable>SETTINGS_FILE</variable>
315             </org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
316           </managedFiles>
317         </org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep>
318         <EnvInjectBuilder>
319           <info>
320             <propertiesContent>SERVER_ID=logs</propertiesContent>
321           </info>
322         </EnvInjectBuilder>
323         <hudson.tasks.Shell>
324           <command>#!/bin/bash
325 # SPDX-License-Identifier: EPL-1.0
326 ##############################################################################
327 # Copyright (c) 2017 The Linux Foundation and others.
328 #
329 # All rights reserved. This program and the accompanying materials
330 # are made available under the terms of the Eclipse Public License v1.0
331 # which accompanies this distribution, and is available at
332 # http://www.eclipse.org/legal/epl-v10.html
333 ##############################################################################
334 echo &quot;---&gt; create-netrc.sh&quot;
335
336 # Ensure we fail the job if any steps fail.
337 set -eu -o pipefail
338
339 NEXUS_URL=&quot;${NEXUSPROXY:-$NEXUS_URL}&quot;
340 CREDENTIAL=$(xmlstarlet sel -N &quot;x=http://maven.apache.org/SETTINGS/1.0.0&quot; \
341     -t -m &quot;/x:settings/x:servers/x:server[x:id='${SERVER_ID}']&quot; \
342     -v x:username -o &quot;:&quot; -v x:password \
343     &quot;$SETTINGS_FILE&quot;)
344
345 machine=$(echo &quot;$NEXUS_URL&quot; | awk -F/ '{print $3}')
346 user=$(echo &quot;$CREDENTIAL&quot; | cut -f1 -d:)
347 pass=$(echo &quot;$CREDENTIAL&quot; | cut -f2 -d:)
348
349 echo &quot;machine ${machine%:*} login $user password $pass&quot; &gt; ~/.netrc
350 </command>
351         </hudson.tasks.Shell>
352         <hudson.tasks.Shell>
353           <command>#!/bin/bash
354 # SPDX-License-Identifier: EPL-1.0
355 ##############################################################################
356 # Copyright (c) 2017 The Linux Foundation and others.
357 #
358 # All rights reserved. This program and the accompanying materials
359 # are made available under the terms of the Eclipse Public License v1.0
360 # which accompanies this distribution, and is available at
361 # http://www.eclipse.org/legal/epl-v10.html
362 ##############################################################################
363 echo &quot;---&gt; lftools-install.sh&quot;
364
365 # Script to install lftools via a version passed in via lf-infra-parameters
366 #
367 # Required parameters:
368 #
369 #     LFTOOLS_VERSION: Passed in via lf-infra-parameters configuration. Can be
370 #                      set to a strict version number like '1.2.3' or using
371 #                      PEP-440 definitions.
372 #
373 #                      Examples:
374 #                          &lt;1.0.0
375 #                          &gt;=1.0.0,&lt;2.0.0
376 #
377 # By default a released version of lftools should always be used.
378 # The purpose of the 2 variables below is so that lftools devs can test
379 # unreleased versions of lftools. There are 2 methods to install a dev version
380 # of lftools:
381 #
382 #     1) gerrit patch: Used to test a patch that has not yet been merged.
383 #                      To do this set something like this:
384 #                          LFTOOLS_MODE=gerrit
385 #                          LFTOOLS_REFSPEC=refs/changes/96/5296/7
386 #
387 #     2) git branch: Used to install an lftools version from a specific branch.
388 #                    To use this set the variables as follows:
389 #                          LFTOOLS_MODE=git
390 #                          LFTOOLS_REFSPEC=master
391 #
392 #     3) release : The intended use case and default setting.
393 #                  Set LFTOOLS_MODE=release, in this case LFTOOLS_REFSPEC is unused.
394
395 LFTOOLS_MODE=release  # release | git | gerrit
396 LFTOOLS_REFSPEC=master
397
398 # Ensure we fail the job if any steps fail.
399 # DO NOT set -u as virtualenv's activate script has unbound variables
400 set -e -o pipefail
401
402 virtualenv --quiet &quot;/tmp/v/lftools&quot;
403 # shellcheck source=/tmp/v/lftools/bin/activate disable=SC1091
404 source &quot;/tmp/v/lftools/bin/activate&quot;
405 pip install --quiet --upgrade pip
406
407 case $LFTOOLS_MODE in
408     gerrit)
409         git clone https://gerrit.linuxfoundation.org/infra/releng/lftools.git /tmp/lftools
410         pushd /tmp/lftools
411         git fetch origin &quot;$LFTOOLS_REFSPEC&quot;
412         git checkout FETCH_HEAD
413         pip install --quiet --upgrade -r requirements.txt
414         pip install --quiet --upgrade -e .
415         popd
416         ;;
417
418     git)
419         pip install --quiet --upgrade git+https://gerrit.linuxfoundation.org/infra/releng/lftools.git@&quot;$BRANCH&quot;
420         ;;
421
422     release)
423         if [[ $LFTOOLS_VERSION =~ ^[0-9] ]]; then
424             LFTOOLS_VERSION=&quot;==$LFTOOLS_VERSION&quot;
425         fi
426
427         pip install --quiet --upgrade &quot;lftools${LFTOOLS_VERSION}&quot;
428         ;;
429 esac
430
431 lftools --version
432
433 # pipdeptree prints out a lot of information because lftools pulls in many
434 # dependencies. Let's only print it if we want to debug.
435 # echo &quot;----&gt; Pip Dependency Tree&quot;
436 # pip install --quiet --upgrade pipdeptree
437 # pipdeptree
438
439 #!/bin/bash
440 # SPDX-License-Identifier: EPL-1.0
441 ##############################################################################
442 # Copyright (c) 2017 The Linux Foundation and others.
443 #
444 # All rights reserved. This program and the accompanying materials
445 # are made available under the terms of the Eclipse Public License v1.0
446 # which accompanies this distribution, and is available at
447 # http://www.eclipse.org/legal/epl-v10.html
448 ##############################################################################
449 echo &quot;---&gt; logs-deploy.sh&quot;
450
451 # Ensure we fail the job if any steps fail.
452 set -eu -o pipefail
453
454 set -x  # Trace commands for this script to make debugging easier.
455
456 ARCHIVE_ARTIFACTS=&quot;${ARCHIVE_ARTIFACTS:-}&quot;
457 LOGS_SERVER=&quot;${LOGS_SERVER:-None}&quot;
458
459 if [ &quot;${LOGS_SERVER}&quot; == 'None' ]
460 then
461     set +x # Disable trace since we no longer need it
462
463     echo &quot;WARNING: Logging server not set&quot;
464 else
465     NEXUS_URL=&quot;${NEXUSPROXY:-$NEXUS_URL}&quot;
466     NEXUS_PATH=&quot;${SILO}/${JENKINS_HOSTNAME}/${JOB_NAME}/${BUILD_NUMBER}&quot;
467     BUILD_URL=&quot;${BUILD_URL}&quot;
468
469     lftools deploy archives -p &quot;$ARCHIVE_ARTIFACTS&quot; &quot;$NEXUS_URL&quot; &quot;$NEXUS_PATH&quot; &quot;$WORKSPACE&quot;
470     lftools deploy logs &quot;$NEXUS_URL&quot; &quot;$NEXUS_PATH&quot; &quot;$BUILD_URL&quot;
471
472     set +x  # Disable trace since we no longer need it.
473
474     echo &quot;Build logs: &lt;a href=\&quot;$LOGS_SERVER/$NEXUS_PATH\&quot;&gt;$LOGS_SERVER/$NEXUS_PATH&lt;/a&gt;&quot;
475 fi
476 </command>
477         </hudson.tasks.Shell>
478         <hudson.tasks.Shell>
479           <command>#!/bin/bash
480 # SPDX-License-Identifier: EPL-1.0
481 ##############################################################################
482 # Copyright (c) 2017 The Linux Foundation and others.
483 #
484 # All rights reserved. This program and the accompanying materials
485 # are made available under the terms of the Eclipse Public License v1.0
486 # which accompanies this distribution, and is available at
487 # http://www.eclipse.org/legal/epl-v10.html
488 ##############################################################################
489
490 # Clear log credential files
491 rm &quot;$SETTINGS_FILE&quot;
492 rm ~/.netrc
493 </command>
494         </hudson.tasks.Shell>
495         <hudson.plugins.descriptionsetter.DescriptionSetterBuilder>
496           <regexp>^Build logs: .*</regexp>
497         </hudson.plugins.descriptionsetter.DescriptionSetterBuilder>
498       </buildSteps>
499       <scriptOnlyIfSuccess>false</scriptOnlyIfSuccess>
500       <scriptOnlyIfFailure>false</scriptOnlyIfFailure>
501       <markBuildUnstable>false</markBuildUnstable>
502     </org.jenkinsci.plugins.postbuildscript.PostBuildScript>
503     <hudson.plugins.ws__cleanup.WsCleanup plugin="ws-cleanup">
504       <patterns>
505         <hudson.plugins.ws__cleanup.Pattern>
506           <pattern>**/*.jenkins-trigger</pattern>
507           <type>EXCLUDE</type>
508         </hudson.plugins.ws__cleanup.Pattern>
509       </patterns>
510       <deleteDirs>false</deleteDirs>
511       <cleanupMatrixParent>false</cleanupMatrixParent>
512       <externalDelete/>
513       <cleanWhenSuccess>true</cleanWhenSuccess>
514       <cleanWhenUnstable>true</cleanWhenUnstable>
515       <cleanWhenFailure>true</cleanWhenFailure>
516       <cleanWhenNotBuilt>true</cleanWhenNotBuilt>
517       <cleanWhenAborted>true</cleanWhenAborted>
518       <notFailBuild>true</notFailBuild>
519     </hudson.plugins.ws__cleanup.WsCleanup>
520   </publishers>
521   <buildWrappers>
522     <com.michelin.cio.hudson.plugins.maskpasswords.MaskPasswordsBuildWrapper/>
523     <hudson.plugins.build__timeout.BuildTimeoutWrapper>
524       <timeoutMinutes>10</timeoutMinutes>
525       <timeoutEnvVar>BUILD_TIMEOUT</timeoutEnvVar>
526       <failBuild>true</failBuild>
527       <writingDescription>false</writingDescription>
528       <timeoutPercentage>0</timeoutPercentage>
529       <timeoutMinutesElasticDefault>3</timeoutMinutesElasticDefault>
530       <timeoutType>absolute</timeoutType>
531     </hudson.plugins.build__timeout.BuildTimeoutWrapper>
532     <hudson.plugins.timestamper.TimestamperBuildWrapper/>
533     <com.cloudbees.jenkins.plugins.sshagent.SSHAgentBuildWrapper>
534       <user>test-credential</user>
535     </com.cloudbees.jenkins.plugins.sshagent.SSHAgentBuildWrapper>
536     <jenkins.plugins.openstack.compute.JCloudsOneOffSlave/>
537     <org.jenkinsci.plugins.configfiles.buildwrapper.ConfigFileBuildWrapper plugin="config-file-provider">
538       <managedFiles>
539         <org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
540           <fileId>npmrc</fileId>
541           <targetLocation>$HOME/.npmrc</targetLocation>
542           <variable/>
543         </org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
544       </managedFiles>
545     </org.jenkinsci.plugins.configfiles.buildwrapper.ConfigFileBuildWrapper>
546   </buildWrappers>
547 </project>